'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                          All rights reserved.                              *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/X21bis.bas $
'*
'*      $Id: X21bis.bas 1.3 2000/02/28 23:55:40 tiktin Release $
'*
'*  MODULE DESCRIPTION
'*
'*    Exports defined constants for the X.21 bis layer.
'*
'******************************************************************************

Attribute VB_Name = "X21bisModule"

Option Explicit

Public Const phys_SIGNAL_CTS As Long = &H1&
Public Const phys_SIGNAL_DCD As Long = &H2&
Public Const phys_SIGNAL_DSR As Long = &H4&
Public Const phys_SIGNAL_FLG As Long = &H8&
Public Const phys_SIGNAL_RTS As Long = &H20&
Public Const phys_SIGNAL_DTR As Long = &H40&

Public Const phys_CLOCK_SINK As Integer = 0
Public Const phys_CLOCK_SOURCE As Integer = 1
Public Const phys_CLOCK_SYMMETRIC As Integer = 2
Public Const phys_CLOCK_SINK_RX As Integer = 3
Public Const phys_CLOCK_SINK_TX As Integer = 4
Public Const phys_CLOCK_SINK_NOISE_SUPPRESS As Integer = 5
Public Const phys_CLOCK_NRZI_ENCODING As Integer = 6
Public Const phys_CLOCK_FM0_ENCODING As Integer = 7
Public Const phys_CLOCK_FM1_ENCODING As Integer = 8
Public Const phys_CLOCK_MANCHESTER_ENCODING As Integer = 9
Public Const phys_CLOCK_MAX As Integer = 10

Public Const phys_TIMER_CONNECT As Integer = 0
Public Const phys_TIMER_DISCONNECT As Integer = 1
Public Const phys_TIMER_RESET As Integer = 2
Public Const phys_TIMER_RECONNECT As Integer = 3
Public Const phys_TIMER_IDLE As Integer = 4
Public Const phys_TIMER_MAX As Integer = 5

Public Const phys_IOCTL_SWITCH_LINES As Integer = 0
Public Const phys_IOCTL_MODEM_CONTROL As Integer = 1
Public Const phys_IOCTL_GET_SIGNALS As Integer = 2
Public Const phys_IOCTL_MAX As Integer = 3

Public Const phys_SIZEOF_SIGNAL_DATA As Integer = 4

Public Const phys_STAT_FRAMES_SENT As Integer = 0
Public Const phys_STAT_FRAMES_RECEIVED As Integer = 1
Public Const phys_STAT_CRC_ERRORS As Integer = 2
Public Const phys_STAT_LENGTH_ERRORS As Integer = 3
Public Const phys_STAT_ABORTED_FRAMES As Integer = 4
Public Const phys_STAT_IDLE_TIMEOUTS As Integer = 5
Public Const phys_STAT_HARDWARE_ANOMALIES As Integer = 6
Public Const phys_STAT_HARDWARE_NO_BUFFERS As Integer = 7
Public Const phys_STAT_SYSTEM_NO_BUFFERS As Integer = 8
Public Const phys_STAT_MAX As Integer = 9

Public Const phys_MSG_MAX As Integer = 0

'******************************************************************************
'*
'*  Signal data functions
'*
'******************************************************************************

Public Function phys_GetSignals(cid As Integer, signals As Long, cfg As Long) As Boolean
    Dim result As Integer
    Dim size As Integer
    Dim data As Long

    size = phys_SIZEOF_SIGNAL_DATA
    result = lgo_Ioctl(cid, phys_IOCTL_GET_SIGNALS, data, 0, data, size)

    If result >= 0 And size = phys_SIZEOF_SIGNAL_DATA Then
        signals = phys_ExtractSignals(data)
        cfg = phys_ExtractSignalCfg(data)
        phys_GetSignals = 1
    Else
        phys_GetSignals = 0
    End If
End Function

Public Function phys_ExtractSignals(ByVal data As Long) As Long

    phys_ExtractSignals = (data \ &H10000) And &HFFFF&

End Function

Public Function phys_ExtractSignalCfg(ByVal data As Long) As Long

    phys_ExtractSignalCfg = data And &HFFFF&

End Function

'******************************************************************************
'*                                  End of file
'******************************************************************************
