'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                           All rights reserved.                             *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/Hex.bas $
'*
'*      $Id: Hex.bas 1.2 2000/02/29 00:00:09 tiktin Release $
'*
'*  MODULE DESCRIPTION
'*
'*    Exports hex format and byte conversion routines.
'*
'******************************************************************************

Attribute VB_Name = "HexModule"

Option Explicit

Public Function HexFormat(buffer() As Byte, size As Integer, width As Integer) As String
    Dim s As String
    Dim h As String
    Dim i As Integer
    Dim j As Integer

    i = 0

    Do While i < size
        j = i
        Do While j < size And j < i + width
            h = Hex(buffer(j))
            If Len(h) < 2 Then
                s = s & "0" & h & " "
            Else
                s = s & h & " "
            End If
            j = j + 1
        Loop

        Do While j < i + width
            s = s & "   "
            j = j + 1
        Loop

        s = s & " # "

        j = i
        Do While j < size And j < i + width
            If buffer(j) < 32 Or buffer(j) > 126 Then
                s = s & "."
            Else
                s = s & Chr(buffer(j))
            End If
            j = j + 1
        Loop

        i = i + width

        If i < size Then
            s = s & vbCrLf
        End If
    Loop

    HexFormat = s
End Function

Public Sub HexFill(buffer() As Byte, ByVal index As Integer, max As Integer, forward As Boolean)
    Dim i As Integer

    i = 0

    If forward Then
        Do While index < max
            buffer(index) = CByte(65 + (i Mod 26))
            index = index + 1
            i = i + 1
        Loop
    Else
        Do While index < max
            buffer(index) = CByte(90 - (i Mod 26))
            index = index + 1
            i = i + 1
        Loop
    End If
End Sub

Public Function HexToLong(buffer() As Byte, ByVal index As Integer) As Long
    ' Assume little endian
    HexToLong = _
        LeftShift(CLng(buffer(index + 3)), 24) Or _
        LeftShift(CLng(buffer(index + 2)), 16) Or _
        LeftShift(CLng(buffer(index + 1)),  8) Or _
            CLng(buffer(index + 0))
End Function

Public Function HexToShort(buffer() As Byte, ByVal index As Integer) As Long
    ' Assume little endian
    HexToShort = _
        LeftShift(CLng(buffer(index + 1)), 8) Or _
            CLng(buffer(index + 0))
End Function

Private Function LeftShift(n As Long, ByVal e As Integer) As Long
    On Error GoTo ErrHandler

    LeftShift = n * Power2(e)
    Exit Function

ErrHandler:
    LeftShift = 0
    Exit Function
End Function

Private Function Power2(ByVal e As Integer) As Long
    Select Case e
    Case 0
        Power2 = &H1&
    Case 1
        Power2 = &H2&
    Case 2
        Power2 = &H4&
    Case 3
        Power2 = &H8&
    Case 4
        Power2 = &H10&
    Case 5
        Power2 = &H20&
    Case 6
        Power2 = &H40&
    Case 7
        Power2 = &H80&
    Case 8
        Power2 = &H100&
    Case 9
        Power2 = &H200&
    Case 10
        Power2 = &H400&
    Case 11
        Power2 = &H800&
    Case 12
        Power2 = &H1000&
    Case 13
        Power2 = &H2000&
    Case 14
        Power2 = &H4000&
    Case 15
        Power2 = &H8000&
    Case 16
        Power2 = &H10000
    Case 17
        Power2 = &H20000
    Case 18
        Power2 = &H40000
    Case 19
        Power2 = &H80000
    Case 20
        Power2 = &H100000
    Case 21
        Power2 = &H200000
    Case 22
        Power2 = &H400000
    Case 23
        Power2 = &H800000
    Case 24
        Power2 = &H1000000
    Case 25
        Power2 = &H2000000
    Case 26
        Power2 = &H4000000
    Case 27
        Power2 = &H8000000
    Case 28
        Power2 = &H10000000
    Case 29
        Power2 = &H20000000
    Case 30
        Power2 = &H40000000
    Case 31
        Power2 = &H80000000
    Case Else
        Power2 = &H0&
    End Select
End Function

'******************************************************************************
'*                                  End of file                               *
'******************************************************************************
