'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                           All rights reserved.                             *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/Statistics.bas $
'*
'*      $Id: Statistics.bas 1.4 2000/03/08 20:05:04 tiktin Release $
'*
'*  MODULE DESCRIPTION
'*
'*    Exports statistics table access routines.
'*
'******************************************************************************

Attribute VB_Name = "StatisticsModule"

Option Explicit

Public Function GetStatisticsTable(cid As Integer, table As String) As Boolean
    Dim buffer(1024) As Byte
    Dim protocol As Integer
    Dim result As Integer

    result = lgo_GetStatistics(cid, buffer(0), 1024)

    If result > 0 Then
        protocol = lgo_Protocol(cid)
        table = "Statistics on CID " & cid & " - " & lgo_ProtocolMessage(protocol) _
                    & " Layer" & vbCrLf & vbCrLf & FormatStatisticsTable(protocol, buffer)
        GetStatisticsTable = True
    Else
        table = "Failure getting statistics table on CID" & cid & ": " & lgo_ErrorMessage(result)
        GetStatisticsTable = False
    End If
End Function

Private Function FormatStatisticsTable(protocol As Integer, buffer() As Byte) As String
    Dim result As String
    Dim count As Long
    Dim i As Long
    Dim formatStr As String

    formatStr = "@@@@@@@@@@@"

    result = result & Format(HexToLong(buffer, 0), formatStr) & " : Bytes sent" & vbCrLf
    result = result & Format(HexToLong(buffer, 4), formatStr) & " : Bytes received" & vbCrLf & vbCrLf

    count = HexToShort(buffer, 8)
    For i = 0 To count - 1
        result = result & Format(HexToShort(buffer, 10 + (i * 2)), formatStr) & _
                    " : " & lgo_StatisticsMessage(protocol, CInt(i)) & vbCrLf
    Next

    FormatStatisticsTable = result
End Function

'******************************************************************************
'*                                  End of file                               *
'******************************************************************************
