'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                           All rights reserved.                             *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/Status.bas $
'*
'*      $Id: Status.bas 1.2 2000/02/29 00:00:09 tiktin Release $
'*
'*  MODULE DESCRIPTION
'*
'*    Exports status report access routines.
'*
'******************************************************************************

Attribute VB_Name = "StatusModule"

Option Explicit

Public Function GetStatusReport(cid As Integer, report As String) As Boolean
    Dim buffer(1024) As Byte
    Dim result As Integer

    result = lgo_GetStatus(cid, buffer(0), 1024)

    If result > 0 Then
        report = "Status Report on CID " & cid & vbCrLf & vbCrLf & _
                         FormatStatusReport(buffer)
        GetStatusReport = True
    Else
        report = "Failure getting status report on CID" & cid & ": " & lgo_ErrorMessage(result)
        GetStatusReport = False
    End If
End Function

Private Function FormatStatusReport(buffer() As Byte) As String
    Dim result As String
    Dim count As Long
    Dim i As Long

    count = HexToShort(buffer, 0)
    For i = 0 To count - 1
        result = result & SummaryToString(buffer, 2 + (i * 18))
    Next

    FormatStatusReport = result
End Function

Private Function SummaryToString(buffer() As Byte, i As Integer)
    SummaryToString = _
        "Status of layer: '" & lgo_ProtocolMessage(HexToShort(buffer, i)) & "' <" & _
            HexToShort(buffer, i + 2) & ", " & HexToShort(buffer, i + 4) & ">" & vbCrLf & _
            "   State:        " & lgo_StateMessage(HexToShort(buffer, i + 6)) & vbCrLf & _
            "   Blocked?:     " & CBool(HexToShort(buffer, i + 8)) & vbCrLf & _
            "   Blocking?:    " & CBool(HexToShort(buffer, i + 10)) & vbCrLf & _
            "   [Up " & HexToShort(buffer, i + 12) & "] [Down " & HexToShort(buffer, i + 14) & "] [Control " & HexToShort(buffer, i + 16) & "]" & vbCrLf & vbCrLf
End Function

'******************************************************************************
'*                                  End of file                               *
'******************************************************************************
