'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                           All rights reserved.                             *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/Using.bas $
'*
'*      $Id: Using.bas 1.3 2000/04/18 00:24:23 tiktin Exp $
'*
'*  MODULE DESCRIPTION
'*
'*    Exports using VbTdrv text access routine.
'*
'******************************************************************************

Attribute VB_Name = "UsingModule"

Option Explicit

Public Function GetUsingText() As String
    Dim str As String

    str = ""
    str = str & "**************************************************************" & vbCrLf
    str = str & "*                                                            *" & vbCrLf
    str = str & "*                         LayGO (tm)                         *" & vbCrLf
    str = str & "*    Copyright (c) 1998-2000 by Advanced Relay Corporation   *" & vbCrLf
    str = str & "*                   All rights reserved.                     *" & vbCrLf
    str = str & "*                                                            *" & vbCrLf
    str = str & "**************************************************************" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Using VbTdrv" & vbCrLf
    str = str & "------------" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "VbTdrv is a Win32 LayGO program written in Visual Basic." & vbCrLf
    str = str & "VbTdrv is designed to test the LayGO device driver and" & vbCrLf
    str = str & "communication board with the protocol stack software.  It" & vbCrLf
    str = str & "can be used in either hardware loopback mode or to connect" & vbCrLf
    str = str & "to another system in a 'back-to-back' setup." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "VbTdrv uses only the X.21 bis physical layer protocol.  It" & vbCrLf
    str = str & "is not a general LayGO test program, and it is not designed" & vbCrLf
    str = str & "to connect to a network or other equipment requiring higher" & vbCrLf
    str = str & "layer protocols.  However, it may be used to test the" & vbCrLf
    str = str & "physical connection to such a network or device.  VbTdrv" & vbCrLf
    str = str & "will display the status of the physical signals and the" & vbCrLf
    str = str & "contents of any frames received.  Using the Test Data" & vbCrLf
    str = str & "feature discussed below, the user can also send previously" & vbCrLf
    str = str & "prepared frames to emulate a higher layer protocol." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Starting VbTdrv:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "The command-line syntax for VbTdrv is:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "     vbtdrv [ cfg file list ]" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "where [ cfg file list ] is an ordered list of .cfg files" & vbCrLf
    str = str & "VbTdrv will use to configure the stack at startup.  For" & vbCrLf
    str = str & "instance, to test hardware loopback, start VbTdrv with the" & vbCrLf
    str = str & "command-line:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "     vbtdrv stackx.cfg x21loop.cfg" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "where the 'x' in 'stackx.cfg' is the LayGO Board Identifier" & vbCrLf
    str = str & "for the installed device driver, such as '6' for the LayGO" & vbCrLf
    str = str & "Hardware Emulator." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Running VbTdrv:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "10 buttons on the main display control the operation of" & vbCrLf
    str = str & "VbTdrv.  Most button names are shortened versions of the" & vbCrLf
    str = str & "LayGO API functions they invoke.  (The exception is 'Full" & vbCrLf
    str = str & "Duplex' which toggles full speed data transfer.)  The" & vbCrLf
    str = str & "operations available at any time depend on the state of the" & vbCrLf
    str = str & "connection.  Buttons for operations which are not available" & vbCrLf
    str = str & "are grayed out but become active as VbTdrv changes state." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "To start, select a line number, then press 'Open' and either" & vbCrLf
    str = str & "'Connect' or 'Listen'." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Menu Options:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "   Logging" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "The Logging menu allows the user to set the level of detail" & vbCrLf
    str = str & "displayed in the log window and to clear the log display." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "   Statistics" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "The Statistics menu gives the user access to statistics and" & vbCrLf
    str = str & "status report data from an open X.21 bis device.  It also" & vbCrLf
    str = str & "allows the user to clear the device statistics and the send" & vbCrLf
    str = str & "and receive counters in the display." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "   Data" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "The Data menu allows the user to load test data frames" & vbCrLf
    str = str & "from a file and, once in data transfer state, to select" & vbCrLf
    str = str & "individual frames to send." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Verified Transmission:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "When VbTdrv exchanges data with another system, the user" & vbCrLf
    str = str & "can choose to enable the verified transmission protocol." & vbCrLf
    str = str & "Using this protocol, each system repeatedly sends a" & vbCrLf
    str = str & "predetermined sequence of frames.  Since the contents of" & vbCrLf
    str = str & "every frame is known in advance, the receiver can verify" & vbCrLf
    str = str & "that the frames are received correctly and in order and" & vbCrLf
    str = str & "report any discrepancies.  Verified transmission provides" & vbCrLf
    str = str & "an automated test of the physical integrity of the installed" & vbCrLf
    str = str & "communication equipment, but requires 2 systems each running" & vbCrLf
    str = str & "VbTdrv." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Test Data:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Test data frames are prerecorded byte sequences which can be" & vbCrLf
    str = str & "read into the program as binary data from a ordinary text" & vbCrLf
    str = str & "file.  The default extension for test data files is .dat." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Each frame in the file begins with a title enclosed in" & vbCrLf
    str = str & "square brackets followed by any number of lines of hex-coded" & vbCrLf
    str = str & "bytes.  Blank lines and lines starting with a '#' (pound" & vbCrLf
    str = str & "sign) are ignored.  The following is a sample file which" & vbCrLf
    str = str & "contains 12 HDLC LAPB supervisory frames:" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    #" & vbCrLf
    str = str & "    #   lapb.dat" & vbCrLf
    str = str & "    #" & vbCrLf
    str = str & "    #   HDLC LAPB supervisory frames (modulo 8)" & vbCrLf
    str = str & "    #" & vbCrLf
    str = str & "    [DTE SABM P=0]" & vbCrLf
    str = str & "    01 2F" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DTE SABM P=1]" & vbCrLf
    str = str & "    01 3F" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE SABM P=0]" & vbCrLf
    str = str & "    03 2F" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE SABM P=1]" & vbCrLf
    str = str & "    03 3F" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DTE DISC P=0]" & vbCrLf
    str = str & "    01 43" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DTE DISC P=1]" & vbCrLf
    str = str & "    01 53" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE DISC P=0]" & vbCrLf
    str = str & "    03 43" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE DISC P=1]" & vbCrLf
    str = str & "    03 53" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DTE UA P=0]" & vbCrLf
    str = str & "    03 63" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DTE UA P=1]" & vbCrLf
    str = str & "    03 73" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE UA P=0]" & vbCrLf
    str = str & "    01 63" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    [DCE UA P=1]" & vbCrLf
    str = str & "    01 73" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "    #" & vbCrLf
    str = str & "    #   end of lapb.dat" & vbCrLf
    str = str & "    #" & vbCrLf
    str = str & "" & vbCrLf
    str = str & "Although VbTdrv does not use the LAPB protocol, these frames" & vbCrLf
    str = str & "could be used to test whether a LAPB link can be established" & vbCrLf
    str = str & "over a  particular physical connection." & vbCrLf
    str = str & "" & vbCrLf
    str = str & "**************************************************************" & vbCrLf
    str = str & "*                          End of file                       *" & vbCrLf
    str = str & "**************************************************************" & vbCrLf

    GetUsingText = str
End Function

'******************************************************************************
'*                                  End of file                               *
'******************************************************************************
