'******************************************************************************
'*                                                                            *
'*                                LayGO (tm)                                  *
'*           Copyright (c) 1998-2000 by Advanced Relay Corporation            *
'*                           All rights reserved.                             *
'*                                                                            *
'******************************************************************************
'*
'*  $Source: q:/laygorcs/VbMain.bas $
'*
'*      $Id: VbMain.bas 1.2 2000/02/29 00:00:10 tiktin Release $
'*
'*  MODULE DESCRIPTION
'*
'*    Main entry point for the VbTdrv program.
'*
'******************************************************************************

Attribute VB_Name = "MainModule"

Option Explicit

Private Sub Main()
    If LoadCfgFiles() < 0 Then
        End
    End If

    If InitializeStack() < 0 Then
        End
    End If

    MainForm.Show
End Sub

Private Function InitializeStack() As Integer
    Dim result As Integer

    result = lgo_InitializeStack(1, 1)

    If result < 0 Then
        PostFatal "Failure initializing stack: " & lgo_ErrorMessage(result)
        InitializeStack = -1
    Else
        result = lgo_EnableStack()
        InitializeStack = 0
    End If
End Function

Private Function LoadCfgFiles() As Integer
    Dim result As Integer
    Dim cmd As String
    Dim cfg As String
    Dim i As Long

    cmd = Trim(Command())

    LoadCfgFiles = -1

    Do While Len(cmd) > 0
        i = InStr(cmd, " ")
        If i > 0 Then
            cfg = Trim(Left(cmd, i))
            cmd = Trim(Right(cmd, Len(cmd) - i))
        Else
            cfg = cmd
            cmd = ""
        End If
        result = lgo_ConfigureStack(cfg)

        If result < 0 Then
            PostFatal "Failure configuring stack with '" & cfg & "': " & vbCrLf & lgo_ErrorMessage(result)
            Exit Function
        End If
    Loop

    LoadCfgFiles = 0
End Function

Private Sub PostFatal(str As String)
    MsgBox "Fatal Error: " & vbCrLf & vbCrLf & str, vbOKOnly + vbCritical, "VbTdrv"
End Sub

'******************************************************************************
'*                                  End of file                               *
'******************************************************************************
